package de.hdm_stuttgart.mi.sd1.task1;

/**
 * <p>Categorizing integer sequences.</p>
 *
 * <p>Examples:</p>
 *
 * <ul>
 *     <li><code>{1, 7, 9, 10}</code> is a sequence of {@link #ASCENDING} values</li>
 *     <li><code>{9, 0, -2, -2}</code> is a sequence of {@link #DESCENDING} values</li>
 *     <li><code>{4, 7, 1, -3}</code> is a sequence of {@link #OSCILLATING} values</li>
 *     <li><code>{1, 1, 1, 1}</code> is a sequence of {@link #CONSTANT} values</li>
 * </ul>
 *
 * <p>An arbitrary such sequence my ma categorized by {@link #getSequenceCategory(int[])}.</p>
 */
public enum C_SequenceCategory {

    /**
     * A sequence of ascending values like {-5, 3, 7, 7, 7, 13}
     */
    ASCENDING,
    /**
     * A sequence of descending values like {0, 0, 0, 0, -1}
     */
    DESCENDING,
    /**
     * A sequence of oscillating values like {1, 3, 1}
     */
    OSCILLATING,
    /**
     * A constant sequence like {3, 3, 3, 3, 3}
     */
    CONSTANT;

    /**
     * <p>Categorize a sequence of values being either constant, ascending, descending or oscillating.</p>
     *
     * <p>A sequence of <code>int</code> values belongs to exactly one of the following categories:</p>
     *
     * <ul>
     *     <li>{@link #ASCENDING}</li>
     *     <li>{@link #DESCENDING}</li>
     *     <li>{@link #OSCILLATING}</li>
     *     <li>{@link #CONSTANT}</li>
     * </ul>
     *
     * <p>See each of the above for an example. For completeness we define both the empty sequence {} and all sequences
     * containing just one element e.g. {-5} to be {@link #CONSTANT}.</p>
     *
     * <section class="implementationHints">
     *     <h4>Hints:</h4>
     *
     *     <ul>
     *         <li><p>Handle special cases e.g. shorter sequences separately.</p></li>
     *         <li>
     *             <p>Use a loop to determine, whether:</p>
     *             <ul>
     *                 <li>There is at least one ascending step from a sequence element to its successor.</li>
     *                 <li>There is at least one descending step from a sequence element to its successor.</li>
     *             </ul>
     *         </li>
     *     </ul>
     * </section>
     *
     * @param sequence A sequence of <code>int</code> values.
     * @return Either of {@link #ASCENDING}, {@link #DESCENDING}, {@link #OSCILLATING} or {@link #CONSTANT}.
     */
    static public C_SequenceCategory getSequenceCategory(final int[] sequence) {
        return ASCENDING; // TODO: Implement me correctly
    }

    private C_SequenceCategory(){/* Ignore me: My sole purpose is suppressing default constructor javadoc generation */}
}
