package de.hdm_stuttgart.mi.sd1.task1;

/**
 * Byte arithmetic mitigations.
 */
public class D_Sum {

    /**
     * <p>Getting the closest <code>byte</code> value to the sum of two bytes.</p>
     * <p>Adding two <code>byte</code> values easily ends in desaster. For example 120 + 10 is larger than
     * 127 or {@link Byte#MAX_VALUE}. Thus <code>127</code> is the closest <code>byte</code> value to the sum in
     * question. This method returns the closest possible <code>byte</code> value:</p>
     *
     * <table class="goikTableDefaults">
     *     <caption>Getting close to the sum of two <code>byte</code> values.</caption>
     *     <tr>
     *         <th>a</th>
     *         <th>b</th>
     *         <th>(a + b) as <code>int</code></th>
     *         <th>Closest <code>byte</code> to (a + b)</th>
     *         <th>Remark</th>
     *     </tr>
     *     <tr>
     *         <td>4</td>
     *         <td>6</td>
     *         <td>10</td>
     *         <td>10</td>
     *         <td>Exact value</td>
     *     </tr>
     *     <tr>
     *         <td>-128</td>
     *         <td>127</td>
     *         <td>-1</td>
     *         <td>-1</td>
     *         <td>Exact value</td>
     *     </tr>
     *     <tr>
     *         <td>120</td>
     *         <td>10</td>
     *         <td>130</td>
     *         <td>127</td>
     *         <td>Closest <code>byte</code> value to 130</td>
     *     </tr>
     *     <tr>
     *         <td>-100</td>
     *         <td>-40</td>
     *         <td>-140</td>
     *         <td>-128</td>
     *         <td>Closest <code>byte</code> value to -140</td>
     *     </tr>
     * </table>
     *
     * <section class="implementationHints">
     *   <h4>Hint:</h4>
     *
     *   <p>First </p>
     *
     * </section>
     *
     * @param a First value
     * @param b Second value
     * @return The closest byte value to the sum of both arguments.
     */
    static public byte mitigatedSum(final byte a, final byte b) {
        return 123; // TODO: Implement me correctly
    }

    private D_Sum() {/* Ignore me: My sole purpose is suppressing default constructor javadoc generation */}
}
