package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import static de.hdm_stuttgart.mi.sd1.task1.A_DrugNdrive.isAllowedToDrive;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class A_DrugNdriveTest extends ExaminationTestDefaults {

    @Marking(points = 8)
    @Test
    public void test_100() {

        Assert.assertTrue(isAllowedToDrive(0, 0, 18, 0));
        Assert.assertTrue(isAllowedToDrive(0, 0, 19, 0));
        Assert.assertTrue(isAllowedToDrive(0, 0, 20, 0));
        Assert.assertTrue(isAllowedToDrive(0, 0, 18, 1));
        Assert.assertTrue(isAllowedToDrive(0, 0, 19, 1));
        Assert.assertTrue(isAllowedToDrive(0, 0, 20, 1));
        Assert.assertTrue(isAllowedToDrive(0, 0, 18, 2));
        Assert.assertTrue(isAllowedToDrive(0, 0, 19, 2));
        Assert.assertTrue(isAllowedToDrive(0, 0, 20, 2));

        Assert.assertTrue(isAllowedToDrive(0, 0, 21, 0));
        Assert.assertTrue(isAllowedToDrive(0, 0, 35, 0));
        Assert.assertTrue(isAllowedToDrive(0, 0, 21, 0));
        Assert.assertTrue(isAllowedToDrive(0, 0, 30, 1));
        Assert.assertTrue(isAllowedToDrive(0, 0, 55, 1));
        Assert.assertTrue(isAllowedToDrive(0, 0, 25, 1));

        Assert.assertFalse(isAllowedToDrive(0, 0.1, 18, 0));

        Assert.assertFalse(isAllowedToDrive(0, 0.1, 19, 0));
        Assert.assertFalse(isAllowedToDrive(0, 0.25, 20, 0));
        Assert.assertFalse(isAllowedToDrive(0, 1.9, 18, 1));
        Assert.assertFalse(isAllowedToDrive(0, 1.5, 19, 1));
        Assert.assertFalse(isAllowedToDrive(0, 0.2, 20, 1));
        Assert.assertFalse(isAllowedToDrive(0, 0.4, 18, 2));
        Assert.assertFalse(isAllowedToDrive(0, 0.2, 19, 2));
        Assert.assertFalse(isAllowedToDrive(0, 0.3, 20, 2));

        Assert.assertFalse(isAllowedToDrive(0, 0.1, 21, 0));
        Assert.assertFalse(isAllowedToDrive(0, 3.0, 35, 0));
        Assert.assertFalse(isAllowedToDrive(0, 0.3, 21, 0));
        Assert.assertFalse(isAllowedToDrive(0, 0.2, 30, 1));
        Assert.assertFalse(isAllowedToDrive(0, 0.1, 55, 1));
        Assert.assertFalse(isAllowedToDrive(0, 1.0, 25, 1));

        Assert.assertFalse(isAllowedToDrive(1.0, 0, 18, 0));

        Assert.assertFalse(isAllowedToDrive(1.1, 0, 19, 0));
        Assert.assertFalse(isAllowedToDrive(1.7, 0, 20, 0));
        Assert.assertFalse(isAllowedToDrive(3.5, 0, 18, 1));
        Assert.assertFalse(isAllowedToDrive(7.2, 0, 19, 1));
        Assert.assertFalse(isAllowedToDrive(1.8, 0, 20, 1));
        Assert.assertFalse(isAllowedToDrive(1.0, 0, 18, 2));
        Assert.assertFalse(isAllowedToDrive(1.5, 0, 19, 2));
        Assert.assertFalse(isAllowedToDrive(3.1, 0, 20, 2));

        Assert.assertFalse(isAllowedToDrive(1.1, 0, 21, 0));
        Assert.assertFalse(isAllowedToDrive(1.0, 0, 35, 0));
        Assert.assertFalse(isAllowedToDrive(3.4, 0, 21, 0));
        Assert.assertFalse(isAllowedToDrive(1.1, 0, 30, 1));
        Assert.assertFalse(isAllowedToDrive(6.0, 0, 55, 1));
        Assert.assertFalse(isAllowedToDrive(4.3, 0, 25, 1));

        Assert.assertFalse(isAllowedToDrive(1.0, 0.1, 18, 0));
        Assert.assertFalse(isAllowedToDrive(1.1, 0.2, 19, 0));
        Assert.assertFalse(isAllowedToDrive(1.7, 0.4, 20, 0));
        Assert.assertFalse(isAllowedToDrive(3.5, 1.8, 18, 1));
        Assert.assertFalse(isAllowedToDrive(7.2, 3.3, 19, 1));
        Assert.assertFalse(isAllowedToDrive(1.8, 0.1, 20, 1));
        Assert.assertFalse(isAllowedToDrive(1.0, 0.2, 18, 2));
        Assert.assertFalse(isAllowedToDrive(1.5, 0.5, 19, 2));
        Assert.assertFalse(isAllowedToDrive(3.1, 1.0, 20, 2));

        Assert.assertFalse(isAllowedToDrive(1.1, 1.0, 21, 0));
        Assert.assertFalse(isAllowedToDrive(1.0, 0.1, 35, 0));
        Assert.assertFalse(isAllowedToDrive(3.4, 0.1, 21, 0));
        Assert.assertFalse(isAllowedToDrive(1.1, 0.1, 30, 1));
        Assert.assertFalse(isAllowedToDrive(6.0, 0.1, 55, 1));
        Assert.assertFalse(isAllowedToDrive(4.3, 0.2, 25, 1));
    }

    @Marking(points = 8)
    @Test
    public void test_200() {

        Assert.assertTrue(isAllowedToDrive(3.4, 0.0, 21, 2));
        Assert.assertTrue(isAllowedToDrive(0, 0.45, 35, 21));
        Assert.assertTrue(isAllowedToDrive(0, 0.4, 21, 20));
        Assert.assertTrue(isAllowedToDrive(2.4, 0.0, 21, 10));
        Assert.assertTrue(isAllowedToDrive(3.4, 0.0, 21, 44));

        Assert.assertFalse(isAllowedToDrive(3.5, 0, 40, 20));
        Assert.assertFalse(isAllowedToDrive(0, 0.5, 40, 20));
        Assert.assertFalse(isAllowedToDrive(7.0, 0, 40, 20));
        Assert.assertFalse(isAllowedToDrive(0, 1.3, 30, 2));
        Assert.assertFalse(isAllowedToDrive(4.4, 0, 35, 10));
        Assert.assertFalse(isAllowedToDrive(0, 4.7, 40, 12));

        Assert.assertFalse("Bad mix alcohol + THC!", isAllowedToDrive(0.1, 0.1, 21, 20));
        Assert.assertFalse("Bad mix alcohol + THC!", isAllowedToDrive(3.4, 0.1, 34, 7));
    }
}