package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.Test;

import static de.hdm_stuttgart.mi.sd1.task1.C_SequenceCategory.getSequenceCategory;
import static de.hdm_stuttgart.mi.sd1.task1.C_SequenceCategory.ASCENDING;
import static de.hdm_stuttgart.mi.sd1.task1.C_SequenceCategory.DESCENDING;
import static de.hdm_stuttgart.mi.sd1.task1.C_SequenceCategory.OSCILLATING;
import static de.hdm_stuttgart.mi.sd1.task1.C_SequenceCategory.CONSTANT;

public class C_SequenceCategoryTest extends ExaminationTestDefaults {

    @Marking(points = 6)
    @Test
    public void test_001_lessThanThree(){
        Assert.assertEquals(CONSTANT, getSequenceCategory(new int[]{}));
        Assert.assertEquals(CONSTANT, getSequenceCategory(new int[]{1}));
        Assert.assertEquals(CONSTANT, getSequenceCategory(new int[]{-3}));
        Assert.assertEquals(CONSTANT, getSequenceCategory(new int[]{-5}));
        Assert.assertEquals(CONSTANT, getSequenceCategory(new int[]{1000}));
        Assert.assertEquals(CONSTANT, getSequenceCategory(new int[]{0}));

        Assert.assertEquals(ASCENDING, getSequenceCategory(new int[]{1, 2}));
        Assert.assertEquals(DESCENDING, getSequenceCategory(new int[]{-4, -5}));
        Assert.assertEquals(CONSTANT, getSequenceCategory(new int[]{-7, -7}));
        Assert.assertEquals(DESCENDING, getSequenceCategory(new int[]{80, 0}));
        Assert.assertEquals(CONSTANT, getSequenceCategory(new int[]{4, 4}));
        Assert.assertEquals(ASCENDING, getSequenceCategory(new int[]{-1, 0}));
    }

    @Marking(points = 6)
    @Test
    public void test_001_larger(){
        Assert.assertEquals(ASCENDING, getSequenceCategory(new int[]{1, 2, 3, 4, 5, 5, 5, 9}));
        Assert.assertEquals(DESCENDING, getSequenceCategory(new int[]{-5, -10, -10, -10}));
        Assert.assertEquals(CONSTANT, getSequenceCategory(new int[]{0, 0, 0, 0, 0, 0, 0, 0}));
        Assert.assertEquals(OSCILLATING, getSequenceCategory(new int[]{0, 0, 1, 2, -5, -8, 0, 0, 0}));
        Assert.assertEquals(ASCENDING, getSequenceCategory(new int[]{-1, 0, 1}));
        Assert.assertEquals(DESCENDING, getSequenceCategory(new int[]{1, 0, -1}));
        Assert.assertEquals(ASCENDING, getSequenceCategory(new int[]{1, 1, 1, 1, 1, 1, 2}));
        Assert.assertEquals(ASCENDING, getSequenceCategory(new int[]{0, 1, 1, 1, 1, 1, 1}));
        Assert.assertEquals(ASCENDING, getSequenceCategory(new int[]{-7, -6, -5}));
        Assert.assertEquals(DESCENDING, getSequenceCategory(new int[]{4, 4, 4, 4, 4, 4, 4, 3}));
        Assert.assertEquals(DESCENDING, getSequenceCategory(new int[]{5, 4, 4, 4, 4, 4, 4, 4}));
    }


}
