package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class D_SumTest extends ExaminationTestDefaults {

    static private void assertByteSum(final int expected, final int i, final int j){
        {
            final String errorMessage = "expected = " + expected + ", a = " + i + " , b = " + j;
            Assert.assertTrue(errorMessage + ": a outside range",
                    Byte.MIN_VALUE <= i & i <= Byte.MAX_VALUE);
            Assert.assertTrue(errorMessage + ": b outside range",
                    Byte.MIN_VALUE <= j & j <= Byte.MAX_VALUE);
            Assert.assertTrue(errorMessage + ": expected outside range",
                    Byte.MIN_VALUE <= expected & expected <= Byte.MAX_VALUE);
        }
        {
            String errorMessage = "Expected mitigatedSum(" + i + " , " + j + ") is " + expected;
            Assert.assertEquals(errorMessage, expected, D_Sum.mitigatedSum((byte)i, (byte) j));
        }
    }

    @Marking(points = 6)
    @Test
    public void test() {
        for (int i = Byte.MIN_VALUE; i <= Byte.MAX_VALUE; i++) {

            final byte
                    lower = (byte) Math.max(Byte.MIN_VALUE - i, Byte.MIN_VALUE),
                    upper = (byte) Math.min(Byte.MAX_VALUE - i, Byte.MAX_VALUE);

            for (int j = Byte.MIN_VALUE; j < lower; j++) {
                assertByteSum(Byte.MIN_VALUE, i, j);
            }
            for (int j = lower; j <= upper; j++) {
                assertByteSum(i + j, i, j);
            }
            for (int j = Byte.MAX_VALUE ; upper < j; j--) {
                assertByteSum(Byte.MAX_VALUE, i, j);
            }
        }
    }
}
